﻿using System;
using System.Windows;
using System.Windows.Controls;
using Microsoft.Phone.Controls;
using Petzold.Phone.EBookReader;

namespace HorrorReader
{
    public partial class ChaptersPage : PhoneApplicationPage
    {
        BookInfo book = (Application.Current as App).CurrentBook;

        public ChaptersPage()
        {
            InitializeComponent();

            // Set CurrentChapterIndex property for bolding
            for (int chapterIndex = 0; chapterIndex < book.Chapters.Count; chapterIndex++)
                book.Chapters[chapterIndex].IsCurrentChapter = (book.CurrentChapterIndex == chapterIndex);

            this.DataContext = book;
            Loaded += OnLoaded;
        }

        void OnLoaded(object sender, RoutedEventArgs args)
        {
            // Attempt to scroll current chapter into view
            chaptersListBox.ScrollIntoView(book.Chapters[book.CurrentChapterIndex]);
        }

        void OnChaptersListBoxSelectionChanged(object sender, SelectionChangedEventArgs args)
        {
            ChapterInfo chapter = chaptersListBox.SelectedItem as ChapterInfo;

            if (chapter != null)
            {
                book.IsChapterAndPageInvalid = true;
                book.CurrentCharacterOffset = chapter.Pages[0].AccumulatedCharacterCount; 
                this.NavigationService.GoBack();
            }
        }
    }
}