﻿using System;
using System.ComponentModel;

namespace Petzold.Phone.EBookReader
{
    public class Annotation : INotifyPropertyChanged, IEquatable<Annotation>
    {
        string note;

        public event PropertyChangedEventHandler PropertyChanged;

        public string Text { set; get; }

        public string Note
        {
            set
            {
                if (note != value)
                {
                    note = value;
                    OnPropertyChanged("Note");
                }
            }
            get { return note; }
        }

        public string ChapterTitle { set; get; }

        public int CharacterOffset { set; get; }

        public double Percentage { set; get; }

        public DateTime DateTime { set; get; }

        public bool Equals(Annotation that)
        {
            return this.CharacterOffset == that.CharacterOffset &&
                   this.DateTime == that.DateTime;
        }

        void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
