﻿using System;
using System.Collections.Generic;
using System.ComponentModel;

namespace Petzold.Phone.EBookReader
{
    public class Bookmark : INotifyPropertyChanged, IEquatable<Bookmark>
    {
        string label;

        public event PropertyChangedEventHandler PropertyChanged;

        public string Label 
        {
            set
            {
                if (label != value)
                {
                    label = value;
                    OnPropertyChanged("Label");
                }
            }
            get { return label; } 
        }

        public string ChapterTitle { set; get; }

        public int CharacterOffset { set; get; }

        public double Percentage { set; get; }

        public DateTime DateTime { set; get; }

        public bool Equals(Bookmark that)
        {
            return this.CharacterOffset == that.CharacterOffset &&
                   this.DateTime == that.DateTime;
        }

        void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
