﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace Petzold.Phone.EBookReader
{
    // For Transition setting
    public class DemoPageProvider : IPageProvider
    {
        public bool SetPageSize(Size pageSize)
        {
            return false;
        }

        public bool SetFont(FontFamily fontFamily, double fontSize)
        {
            return false;
        }

        public FrameworkElement GetPage(int chapterIndex, int pageIndex)
        {
            return new TextBlock
            {
                FontSize = 10,
                TextWrapping = TextWrapping.Wrap,
                Text = "For a long time I used to go to bed early. Sometimes, when I had put out " +
                       "my candle, my eyes would close so quickly that I had not even time to " +
                       "say \"I'm going to sleep.\" And half an hour later the thought that it was " +
                       "time to go to sleep would awaken me; I would try to put away the book " +
                       "which, I imagined, was still in my hands, and to blow out the light; I " +
                       "had been thinking all the time, while I was asleep, of what I had just " +
                       "been reading, but my thoughts had run into a channel of their own, " +
                       "until I myself seemed actually to have become the subject of my book: " +
                       "a church, a quartet, the rivalry between François I and Charles V. This " +
                       "impression would persist for some moments after I was awake; it did not " +
                       "disturb my mind, but it lay like scales upon my eyes and prevented them " +
                       "from registering the fact that the candle was no longer burning. Then " +
                       "it would begin to seem unintelligible, as the thoughts of a former " +
                       "existence must be to a reincarnate spirit; the subject of my book would " +
                       "separate itself from me, leaving me free to choose whether I would form " +
                       "part of it or no; and at the same time my sight would return and I " +
                       "would be astonished to find myself in a state of darkness, pleasant and " +
                       "restful enough for the eyes, and even more, perhaps, for my mind, to " +
                       "which it appeared incomprehensible, without a cause, a matter dark " +
                       "indeed."
            };
        }

        public FrameworkElement GetPage(int characterCount, out int chapterIndex, out int pageIndex)
        {
            chapterIndex = 0;
            pageIndex = 0;
            return GetPage(chapterIndex, pageIndex);
        }

        public FrameworkElement QueryLastPage(int chapterIndex, out int pageIndex)
        {
            pageIndex = -1;
            return null;
        }

        public FrameworkElement GetLastPage(int chapterIndex, out int pageIndex)
        {
            pageIndex = -1;
            return null;
        }
    }
}
