﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Petzold.Phone.EBookReader
{
    public class ManipulationThumb : Control
    {
        public event DragStartedEventHandler DragStarted;
        public event DragDeltaEventHandler DragDelta;
        public event DragCompletedEventHandler DragCompleted;

        protected override void OnManipulationStarted(ManipulationStartedEventArgs args)
        {
            if (DragStarted != null)
            {
                DragStartedEventArgs evtArgs = new DragStartedEventArgs(0, 0);
                DragStarted(this, evtArgs);
            }
            base.OnManipulationStarted(args);
        }

        protected override void OnManipulationDelta(ManipulationDeltaEventArgs args)
        {
            if (DragDelta != null)
            {
                DragDeltaEventArgs evtArgs = new DragDeltaEventArgs(args.DeltaManipulation.Translation.X, args.DeltaManipulation.Translation.Y);
                DragDelta(this, evtArgs);
            }
            base.OnManipulationDelta(args);
        }

        protected override void OnManipulationCompleted(ManipulationCompletedEventArgs args)
        {
            if (DragCompleted != null)
            {
                DragCompletedEventArgs evtArgs = new DragCompletedEventArgs(0, 0, false);
                DragCompleted(this, evtArgs);
            }

            base.OnManipulationCompleted(args);
        }
    }
}
